////////////////////////////////////////////
//LCDɃf[^\
////////////////////////////////////////////

#define G__EXTERN__ extern

#include "mc400.h"
#include "lcd.h"

//////////////////////////////
//s32->ϊ
//El
//擪ʒuԂ
char *s32toa(s32 dt, char *s, int len)
{
  int d, n, cnt;
	char *w;
	s32 x;
	
	if (dt<0)
	  x=dt * -1;
	else  
    x=dt;
	
	cnt=0;
    	
	s += len;
	*s = '\0';
	do{
		d = x % 10;
    n = (x >= 10);
		x /= 10;
		d += '0';
		*--s = d;
		len--;

		cnt++;
		if (3==cnt || 6==cnt){
		  *--s='.';
		  len--;
		}  
	}while(n == 1 && len > 0);
	
	if (*s=='.'){
	  len++;
	  s++;
	}  
	
	w=s;  //擪ʒu

	for(;len > 0;len--){
		if (len==4 || len==8)
		  *--s = '.';
		else  
    	*--s = '0';
  }   	

	return w;
}

///////////////////////////////////////////
//  0123456789012345
//  R 000.000.000 00(MA,ST)
//  +           1 01
//////////////////////////////////////
//J[\ʒuigXebvjɃZbg
void fhz_cursor_step_set(void)
{
	long int wk;
  int i;
  	
  wk=fhz_step;
  
  for (i=0; i<9; i++){
	  wk=wk/10;
	  if (wk==0)
	    break;
	}   
	
	if (i>5)           //sIh2
	  i+=2;
	else if (i>2)     //sIh1
    i++;
		  
  LCDgotoxy(12-i, 0);
}

//////////////////////////////////////
//J[\ʒuiRITXebvjɃZbg
void rit_cursor_step_set(void)
{
	long int wk;
  int i;
  	
  wk=rit_step;
  
  for (i=0; i<9; i++){
	  wk=wk/10;
	  if (wk==0)
	    break;
	}

  if (i>5)           //sIh2
	  i+=2;
	else if (i>2)     //sIh1
    i++;

  LCDgotoxy(12-i, 1);
}
	
///////////////////////////////////
//g\
//fhz = 1HzP
void fhz_view(void)
{
  char s[20];
  long int fhz, d, f;
  
  if (0==fhz_gyaku_base){  //ʏ̔U
    fhz=fhz_pll * fhz_teibai + fhz_offset; //\g=Ug@@{@{@ItZbg
  }else{                   //tU@@fhz_pll͕\ƃXebv͔ΕɓĂ
                           //lfhz_pll=fhz_gyaku_baseɃZbgĂ
    d=fhz_pll - fhz_gyaku_base; //gtUx[Xǂꂾ
    f=fhz_gyaku_base - d;       //\̓x[Xtɓ -10@Ȃ +10
    fhz=f * fhz_teibai + fhz_offset; //\pgɉH@
  }
    
  s32toa(fhz, s, 11);

  LCDputs_xy(2, 0, s);

  fhz_cursor_step_set();  //J[\ʒuĐݒ
}

///////////////////////////////////
//RITg΍\
//fhz = 1HzP
void rit_view(void)
{
  char s[20];
 
  s32toa(rit_offset, s, 11);

  if (rit_offset<0)
    LCDputs_xy(0, 1, "-");
  else  
    LCDputs_xy(0, 1, "+");
    
  if (1==rit_sw)     
    LCDputs("*");    //RIT on
  else
    LCDputs(" ");

  LCDputs_xy(2, 1, s);
     
  rit_cursor_step_set();  //J[\ʒuĐݒ
};
  
////////////////////////////////////////////////
//[`l@\
//wk 1:ݒς݁@0:ݒ 2:\͂̂܂
void ch_view(int wk)
{
  char s[20];

  
  if (1==wk)
    LCDputs_xy(13, 1, "*");
  if (0==wk)
    LCDputs_xy(13, 1, " ");

    
  s32toa(ch_no, s, 2);
  LCDputs_xy(14, 1, s);
  LCDgotoxy(15, 1);
};	

////////////////////////////////////////////////
//o̓x@\Ɛݒ
//00=ST 100=MX 01`99
void out_level_view(void)
{
  char s[20];

   
  s32toa(out_level, s, 2);
  
  if (100==out_level)
    LCDputs_xy(14, 0, "MX");
  else
    LCDputs_xy(14, 0, s);
    
  LCDgotoxy(15, 0);
  
  dds_asf_set(out_level); //o̓xݒ

};	
