///////////////////////////////
//FLASH
//////////////////////////////
#define G__EXTERN__ extern

#include <libpic30.h>
#include "mc400.h"

#define CH_DAT_MAX 21  /*P`l̃f[^*/

//f[^ۑpFLASH@[̈m
int __attribute__((space(prog),aligned(_FLASH_PAGE*2))) ch_flash[_FLASH_PAGE]; //_FLASH_PAGE=512
int ch_dt[_FLASH_ROW*8]; //_FLASH_ROW     64*8=512


/////////////////////////////////////
//tbV@Cg
void f_write(void)
{
	_prog_addressT p;
  int i;
  int *intp;
	
  intp=ch_dt;

  _init_prog_address(p, ch_flash);
  _erase_flash(p);
  
  for (i=0; i<8; i++){ //byte 1024 int 512
	  _write_flash16(p, intp);  //128byte wirte
	  p+=128;
	  intp+=64;
  };
	
};

/////////////////////////////////////
//tbV@[h
void f_read(void)
{
	_prog_addressT p;
  int i;
  int *intp;

  _init_prog_address(p, ch_flash);
  intp=ch_dt;
  
  for (i=0; i<8; i++){
    _memcpy_p2d16(intp, p, 128);
    p+=128;
    intp+=64;
  };  
};

///////////////////////////////////////////////////////
//tbV
void f_init(void)
{
  int i;
  
  for (i=0; i<512; i++){   //ch_dt0NA
    ch_dt[i]=0;
  };  

  ch_dt[0]=0x55aa;
  ch_dt[1]=pll_x;  //O[oۑ
    
  f_write();
};

/////////////////////////////////////////
//O[oύXꂽꍇ̕ۑ
void f_global_write(void)
{
	ch_dt[1]=pll_x;
	
	f_write();
};
	
///////////////////////////////////////////////////////
//tbV̋Ň
//f[^܂ĂΓǂ
//ȂΏ
void f_on_check(void)
{
	f_read();
	
	if (ch_dt[0]!=0x55aa){ //ĂȂ
    f_init(); //
  	return;
  }; 
  
  pll_x=ch_dt[1];  //O[oۑ̐ݒ  
	
};

	
//////////////////////////////////////
//`l@
//no `lԍ 0`19
void ch_write(int no)
{
  int base;
  
  if (no>MAX_CH_NO)
    return;
  
  base=CH_DAT_MAX * (no+1);    //tbV[ 擪512byte̓`l̊֌WȂf[^̕ۑ

  ch_dt[base]=0x55aa;
  ch_dt[base+1]=(int)(fhz_pll >> 16);
  ch_dt[base+2]=(int)(fhz_pll & 0x0000ffff);
  ch_dt[base+3]=fhz_teibai;
  ch_dt[base+4]=(int)(fhz_offset >> 16);
  ch_dt[base+5]=(int)(fhz_offset & 0x0000ffff);
  ch_dt[base+6]=(int)(fhz_step >> 16);
  ch_dt[base+7]=(int)(fhz_step & 0x0000ffff);
  ch_dt[base+8]=(int)(fhz_gyaku_base >> 16);
  ch_dt[base+9]=(int)(fhz_gyaku_base & 0x0000ffff);
  ch_dt[base+10]=(int)(fhz_sw_offset >> 16);
  ch_dt[base+11]=(int)(fhz_sw_offset & 0x0000ffff);
  ch_dt[base+12]=(int)(rit_offset >> 16);
  ch_dt[base+13]=(int)(rit_offset & 0x0000ffff);
  ch_dt[base+14]=(int)(rit_step >> 16);
  ch_dt[base+15]=(int)(rit_step & 0x0000ffff);
  ch_dt[base+16]=rit_sw;
  ch_dt[base+17]=out_level;

  f_write();
};

//////////////////////////////////////
//`l@ǂݏo
//tbV͖ǂ܂Ȃ
//no `lԍ 0`19
//0Ԃ́AۑpŁAċNɓǂݍ
//`l[hł́AO[oϐɃZbgA0Ԃɂ
//ret 1=Lf[^`lɃZbgĂ@0=ݒ
int ch_read(int no)
{
	int base;

  if (no>MAX_CH_NO)    //19chő 400oCg
    return 2;
  
  base=CH_DAT_MAX * (no+1);    //tbV[ 擪512byte̓`l̊֌WȂf[^̕ۑ

  if (ch_dt[base]!=0x55aa)  //ݒ`l
    return 0;
    
  fhz_pll=(long int)ch_dt[base+1]<<16 | (0xffff & ch_dt[base+2]);
  fhz_teibai=ch_dt[base+3];
  fhz_offset=(long int)ch_dt[base+4]<<16 | (0xffff & ch_dt[base+5]);
  fhz_step=(long int)ch_dt[base+6]<<16 | (0xffff & ch_dt[base+7]);
  fhz_gyaku_base=(long int)ch_dt[base+8]<<16 | (0xffff & ch_dt[base+9]);
  fhz_sw_offset=(long int)ch_dt[base+10]<<16 | (0xffff & ch_dt[base+11]);
  rit_offset=(long int)ch_dt[base+12]<<16 | (0xffff & ch_dt[base+13]);
  rit_step=(long int)ch_dt[base+14]<<16 | (0xffff & ch_dt[base+15]);
  rit_sw=ch_dt[base+16];
  out_level=ch_dt[base+17];
  
  return 1;
};
