///////////////////////////////////////////
// KEM-DDS-AD9953 Ver 3
///////////////////////////////////////////
#define G__EXTERN__

#include "mc400.h"
#include "lcd.h"

///****fobNGCP_OFF ****
// CONFIG2

#pragma config POSCMOD = NONE           // Primary Oscillator Select (Primary oscillator disabled)
#pragma config I2C1SEL = SEC            // I2C1 Pin Location Select (Use default SCL1/SDA1 pins)
#pragma config IOL1WAY = OFF            // IOLOCK Protection (IOLOCK may be changed via unlocking seq)
#pragma config OSCIOFNC = ON            // Primary Oscillator Output Function (OSC2/CLKO/RC15 functions as port I/O (RC15))
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor (Clock switching and Fail-Safe Clock Monitor are disabled)
#pragma config FNOSC = FRCPLL          // Oscillator Select (Fast RC Oscillator with PLL module (FRCPLL))
// #pragma config SOSCSEL = SOSC           // Sec Oscillator Select (Default Secondary Oscillator (SOSC))
// #pragma config WUTSEL = LEG             // Wake-up timer Select (Legacy Wake-up Timer)
#pragma config IESO = OFF               // Internal External Switch Over Mode (IESO mode (Two-Speed Start-up) disabled)

// CONFIG1
// #pragma config WDTPS = PS32768          // Watchdog Timer Postscaler (1:32,768)
// #pragma config FWPSA = PR128            // WDT Prescaler (Prescaler ratio of 1:128)
// #pragma config WINDIS = ON              // Watchdog Timer Window (Standard Watchdog Timer enabled,(Windowed-mode is disabled))
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (Watchdog Timer is disabled)
#pragma config ICS = PGx1               // Comm Channel Select (Emulator EMUC1/EMUD1 pins are shared with PGC1/PGD1)
#pragma config GWRP = OFF               // General Code Segment Write Protect (Writes to program memory are allowed)
#pragma config GCP = ON  //o׎ON       //General Code Segment Code Protect (Code protection is disabled)
#pragma config JTAGEN = OFF             // JTAG Port Enable (JTAG port is disabled)

////////////////////////////////////////////////////
//C
int main(void)
{
  int wk;
	
	init_global();   //O[oϐ
	
	init_port(); //|[g

  LCDinit(); //LCD
  LCDclrscr();
  
  rs232c_init(); //RS232C

  ms_wait(10);

	if (0==SW5){   //
	  ms_wait(200);
    LCDputs_xy(0, 0, "Init OK");
	  while(0==SW5);
    f_init();
  };  

  f_on_check();  //pll_xݒ肳 ߂Ă̏ꍇch_dt0ŏ
    
	if (0==SW1 && 0==SW4){   //{Ȃ400MHz
	  ms_wait(200);
    LCDputs_xy(0, 0, "400MHz PLL=OFF");
	  while(0==SW1);
	  while(0==SW4);
	  pll_x=0;
	  f_global_write();
  };

	if (0==SW1){   //pll x 17
	  ms_wait(200);
    LCDputs_xy(0, 0, "340MHz");
	  while(0==SW1);
	  pll_x=17;
	  f_global_write();
  };
  	  
  if (0==SW2){   //pll x 18
	  ms_wait(200);
    LCDputs_xy(0, 0, "360MHz");
	  while(0==SW2);
	  pll_x=18;
	  f_global_write();
  };
  
	if (0==SW3){   //pll x 19
	  ms_wait(200);
    LCDputs_xy(0, 0, "380MHz");
	  while(0==SW3);
	  pll_x=19;
		  f_global_write();
  };
  
	if (0==SW4){   //pll x 20
	  ms_wait(200);
    LCDputs_xy(0, 0, "400MHz");
	  while(0==SW4);
	  pll_x=20;
	  f_global_write();
  };

  LCDclrscr();
  LCDputs_xy(0, 0, "KEM-DDS Ver 3.10");
  ms_wait(2000);
  LCDclrscr();

  dds_init();  //DDS
  
 	wk=ch_read(ch_no);  //`lǂݏo wk=0 ݒ̏ꍇ init_global()̒lg
  ch_view(wk);     //`l\
  
  out_level_view();  //o̓x
  
  rit_view();    //RIT\
  
 	fhz_set();        //PLLgXV

  LCDputs_xy(0, 0, "R");

 	fhz_view();       //g\XV
 	
	while(1){
		if (0==cmd_mode)
  		btn_chk();      //{^`FbN
  		
		cmd_recv();     //OR}h`FbN
		
		if (0==enc_lock_sw)  //GR[_bNĂȂ
  		enc_updown();   //GR[_
  }; 
};//main
